Unit ID10RP_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ID10RP(var A :Array of Real; T :Real; var E :Array of Real;
                var LC :Integer; LA :Integer; IL :Integer;
                IS_ :Integer; IU :Integer; NO :Integer; L1 :Integer);

implementation

procedure ID10RP(var A :Array of Real; T :Real; var E :Array of Real;
                var LC :Integer; LA :Integer; IL :Integer;
                IS_ :Integer; IU :Integer; NO :Integer; L1 :Integer);
var
I :Integer;
BN,SN,WS,SO :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
SO := _CID10R.elm1;  //  SO     ID10R (  31.08.10)
BN := 0.0;
SN := 0.0;
if ( T ) < 0
 then goto _8
 else if ( T ) > 0
       then goto _1
       else goto _1;
_1:
SN := 0.0;
I := IL;
while ( I<=IU ) do
 begin
  WS := Abs(E[I-1]);
  SN := SN+WS;
  if ( BN-WS ) < 0
   then goto _2
   else if ( BN-WS ) > 0
         then goto _3
         else goto _3;
_2:
  BN := WS;
_3:
  inc(I,IS_);
 end;
SN := SN*(IS_)/(IU-IL+IS_);
if ( LA-L1 ) < 0
 then goto _4
 else if ( LA-L1 ) > 0
       then goto _4
       else goto _8;
_4:
if ( SO-BN ) < 0
 then goto _5
 else if ( SO-BN ) > 0
       then goto _8
       else goto _5;
_5:
if ( LA-NO ) < 0
 then goto _7
 else if ( LA-NO ) > 0
       then goto _7
       else goto _6;
_6:
LC := 4;
goto _14;
_7:
LC := 5;
goto _14;
_8:
I := IL;
while ( I<=IU ) do
 begin
  A[I-1] := A[I-1]+E[I-1];
_9:
  inc(I,IS_);
 end;
_CID10R.elm1 := SN;
if ( BN-T ) < 0
 then goto _10
 else if ( BN-T ) > 0
       then goto _13
       else goto _10;
_10:
if ( LA-NO ) < 0
 then goto _12
 else if ( LA-NO ) > 0
       then goto _12
       else goto _11;
_11:
LC := 2;
goto _14;
_12:
LC := 1;
goto _14;
_13:
LC := 0;
_14:
end;

end.
